在开发中，往往会遇到一些关于延时任务的需求。例如
1. 生成订单30分钟未支付，则自动取消
2. 生成订单60秒后,给用户发短信

对上述的任务，我们给一个专业的名字来形容，那就是延时任务。那么这里就会产生一个问题，这个延时任务和定时任务的区别究竟在哪里呢？一共有如下几点区别:
- 定时任务有明确的触发时间，延时任务没有
- 定时任务有执行周期，而延时任务在某事件触发后一段时间内执行，没有执行周期
- 定时任务一般执行的是批处理操作是多个任务，而延时任务一般是单个任务

解决方案：

1. JDK的延迟队列 (DelayQueue.class)
2. 时间轮算法--HashedWheelTimer
3. Redisson延迟队列RDelayedQueue
前俩方案的优缺点：

优点：
效率高,任务触发时间延迟时间比delayQueue低，代码复杂度比delayQueue低。

缺点：  
(1)服务器重启后，数据全部消失，怕宕机  
(2)集群扩展相当麻烦  
(3)因为内存条件限制的原因，比如下单未付款的订单数太多，那么很容易就出现OOM异常  