## 总结：

if else 的代码无非是根据入参的某一个值，来获取对应实例Service，然后处理。

```java
public PayResponse pay(PayRequestType payRequestType) {
        PayTypeEnum payType = PayTypeEnum.valueOfCode(payRequestType.getPayType()).orElseThrow(IllegalArgumentException::new);
        // 根据payType，来获取对应实例，然后做对应的处理
        if (payType == PayTypeEnum.ALIPAY) {
            return alipayService.pay(payRequestType);
        } else if (payType == PayTypeEnum.WEIXIN) {
            return weixinPayService.pay(payRequestType);
        } else if (payType == PayTypeEnum.LIANLIAN) {
            return lianlianPayService.pay(payRequestType);
        }
        // 其他支付方式
        return null;
    }
```

那么就可以使用策略模式重构